<template>
  <div class="dashboard-content">
    <section class="top-content">
      <div class="bg-wrapper">
        <Background></Background>
      </div>
      <div class="top-content-wrapper">
        <div class="textbox">
          <div class="textbox__title">
            <p class="title">
              {{ $t(status) }}
            </p>
          </div>
        </div>

        <div class="countdown">
          <countdown :target-time="targetTime"></countdown>
        </div>

        <p class="sub-title">
          <span class="sub-title__number">{{ this.totalTokenSold | formatCurrencyAmount('usd', '0') }}</span>
          <span class="sub-title__text">Total HETA token sold</span>
        </p>
        <Progress :totalToken="totalTokenSold"></Progress>

        <div class="buyBtn-wrapper">
          <a href="javascript:void(0)" id="buyToken-btn" class="buyToken-btn" @click="scrollToBuyToken()">
            {{ $t('dashboard.button.buy_heta') }}
          </a>
        </div>

        <time-line :solds="solds"></time-line>

        <div class="arrow-down arrow-group">
          <span class="iconmo-arrow"></span>
          <span class="iconmo-arrow"></span>
        </div>
      </div>
    </section>
    <section class="middle-content" ref="buyToken">
      <buy-token></buy-token>
    </section>

    <section class="bottom-content">
      <history></history>
    </section>
  </div>
</template>
<script>
  import { mapState } from 'vuex';
  import moment from 'moment';
  import BigNumber from 'bignumber.js';

  import Countdown from '../components/Dashboard/Countdown';
  import Progress from '../components/Dashboard/Progress';
  import TimeLine from '../components/Dashboard/TimeLine';
  import rf from '../../common/requests/RequestFactory';
  import History from '../components/Dashboard/History';
  import BuyToken from '../components/Dashboard/BuyToken';
  import Background from '../components/Dashboard/Background';

  export default {
    components : {
      Progress,
      Countdown,
      TimeLine,
      History,
      BuyToken,
      Background,
    },
    computed: {
      ...mapState([
        'systemSettings',
        'currentBonus',
      ]),
      status () {
        const startAt = parseInt(this.systemSettings.ico_start_time || 0);
        const endAt = parseInt(this.systemSettings.ico_end_time || 0);
        const current = moment().valueOf();
        if (current > endAt) {
          return 'dashboard.status.ended';
        } else if (current > startAt && current < endAt) {
          return 'dashboard.status.live';
        }
        return 'dashboard.status.coming';
      },
      targetTime () {
        switch(this.status) {
          case 'dashboard.status.coming':
            return parseInt(this.systemSettings.ico_start_time || 0);
          case 'dashboard.status.live':
            return parseInt(this.systemSettings.ico_end_time || 0);
          default:
            return 0;
        }
      }
    },
    data () {
      return {
        totalTokenSold: 0,
        solds: {}
      }
    },
    methods: {
      async getTotalToken () {
        const result = await rf.getRequest('ConversionRequest').getSold();
        this.solds = Object.assign({}, result.data);
        this.totalTokenSold = BigNumber(this.solds.total).toNumber();
      },
      scrollToBuyToken () {
        let windowHeight = window.innerHeight;
        $('html,body').animate({
            scrollTop: $(".middle-content").offset().top - (windowHeight - $(".middle-content").height())/2 },
          '300');
      },
    },
    created () {
      this.$store.dispatch('fetchBonuses');
      this.getTotalToken();
      this.$on('ConversionCreated', (conversion) => {
        this.totalTokenSold = BigNumber(conversion.token_amount).plus(this.totalTokenSold).toNumber();
        const sold = this.solds[this.currentBonus.timestamp];
        this.solds[this.currentBonus.timestamp] = BigNumber(conversion.total_token_amount).plus(sold).toNumber();
      });
    },
    mounted() {
      if (this.$route.query.currency) {
        this.scrollToBuyToken();
      }
    },
  }
</script>
<style lang="scss" scoped>
  @import '../../../sass/variables';
  @import '../../../sass/vendor/position';

  a,
  a:active,
  a:hover {
    text-decoration: none;
  }

  .dashboard-content {
    position: relative;
    overflow: hidden;
    background-color: $dashboard_bgc;
    min-height: calc(100vh - 406px);
    padding-top: 108px;
  }

  #Background-Canvas {
    @include relative(0,0 , 0, 0);
    width: 100%;
  }

  .bg-wrapper {
    z-index: 1;
    @include absolute(0, 0, null, 0);

     &:before {
       z-index: 100;
       content: '';
       display: block;
       @include absolute(null , 0, 0 , 0);
       width: 100%;
       height: 100px;
       background-image: url('/images/bg_sup_gradient.png');
       background-repeat: repeat-x;
       background-position: 0 100%;
    }
  }

  .top-content-wrapper {
    position: relative;
    z-index: 100;
  }

  .top-content {
    .textbox__title {
      margin-bottom: 40px;
      .title {
        font-size: $agiant;
        font-weight: bold;
        color: #fff;
        text-align: center;
        margin-bottom: 12px;
        line-height: 1;
      }

    }

    .sub-title {
      max-width: 800px;
      margin: 0 auto 8px;

      .sub-title__number {
        vertical-align: middle;
        font-size: 18px;
        font-weight: bold;
        color: $orange;
        margin-right: 5px;
        line-height: 1;
      }

      .sub-title__text {
        vertical-align: middle;
        font-size: $small;
        color: $gray_text_dashboard;
      }
    }

    .buyBtn-wrapper {
      text-align: center;
      margin-bottom: 23px;
      margin-top: 12px;

      .buyToken-btn {
        display: inline-block;
        font-size: $medium;
        font-weight: bold;
        letter-spacing: 1px;
        color: $white;
        padding: 11px 33px;
        background-color: $orange;
        border-radius: 30px;
      }
    }

    .time-line {
      margin-bottom: 66px;
    }

    .arrow-down {
      height: 30px;
      position: relative;
      display: block;
      text-align: center;
      margin-bottom: 84px;
      animation: blinking 2s linear 0s infinite;

      .iconmo-arrow {
        opacity: 0;
        position: absolute;
        left: 50%;
        top: 10px;
        transform: translateX(-50%) rotate(90deg);

        font-size: 15px;
        color: $gray;
        display: block;
      }
    }
  }

  $ani-speed: 2s;
  $ani-delay: 1s;

  .arrow-group {
    .iconmo-arrow:nth-child(1) {
      animation: arrow-movement $ani-speed ease-in-out infinite;
    }
    .iconmo-arrow:nth-child(2) {
      font-size: 15px;
      margin-bottom: -8px;
      animation: arrow-movement $ani-speed $ani-delay ease-in-out infinite;
    }
  }

  .middle-content {
    position: relative;
    z-index: 2;
  }

  // buy history
  .bottom-content {
    max-width: 1130px;
    margin: 96px auto 125px;
    position: relative;
    z-index: 10;
  }

  @keyframes arrow-movement {
    0% {
        opacity: 0;
        top: 0;
    }
    70% {
        opacity: 1;
    }
    100% {
        opacity: 0;
    }
  }

  @media screen and (max-width: 1200px) {
    .dashboard-content {
      .top-content-wrapper {
        max-width: 70%;
        margin: 50px auto 0;
      }

      .bottom-content {
        width: 90%;
        max-width: 921px;
      }
    }
  }
</style>

<style lang="scss">
  * {
    margin: 0;
    padding: 0;
  }
</style>
